// copyright 2023 zamfofex
// license: AGPLv3 or later

#ifndef MIMIMI_ENGINES_H
#define MIMIMI_ENGINES_H

struct mimimi_image;
struct mimimi_allocator;
struct mimimi_size;
struct mimimi_coroutine_provider;

struct mimimi_engine
{
	void *data;
	void *(*texture)(void *data, struct mimimi_image *image);
	void (*invalidate)(void *data, void *texture);
	void (*stamp)(void *data, int x, int y, void *texture);
	struct mimimi_size *size;
	struct mimimi_allocator *allocator;
	struct mimimi_coroutine_provider *coroutines;
};

#endif
